package com.ruoyi.common.utils;


import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.common.core.domain.entity.SysDictData;

import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 数据工具类
 *
 * @author ruoyi
 */
public class DataUtils {

    public static String dateMap = "{\"area\":{ \"1\":\"123\",\"2\":\"124\",\"3\":\"124\",\"4\":\"124\",\"5\":\"124\",\"6\":\"124\",\"7\":\"124\",\"8\":\"124\",\"9\":\"124\",\"10\":\"124\",\"11\":\"124\",\"12\":\"124\",\"13\":\"124\",\"14\":\"124\",\"15\":\"124\",\"16\":\"124\",\"17\":\"124\",\"18\":\"124\",\"19\":\"124\",\"20\":\"124\",\"21\":\"124\",\"22\":\"124\",\"23\":\"124\",\"24\":\"124\"}," +
            "\"street\":{\"1\":\"101\",\"2\":\"103\", \"3\":\"102\", \"4\":\"104\",\"5\":\"105\", \"6\":\"106\", \"7\":\"121\", \"8\":\"120\", \"9\":\"117\", \"10\":\"119\", \"11\":\"118\"}," +
            "\"community\":{\"1\":\"125\",\"2\":\"126\", \"3\":\"127\",\"4\":\"128\", \"5\":\"129\", \"6\":\"130\", \"7\":\"131\", \"17\":\"132\", \"18\":\"133\", \"19\":\"134\", \"20\":\"135\", \"21\":\"136\", \"22\":\"137\", \"23\":\"138\", \"24\":\"139\", \"34\":\"140\", \"35\":\"141\", \"36\":\"142\", \"37\":\"143\", \"38\":\"144\", \"39\":\"145\", \"40\":\"146\", \"41\":\"147\", \"42\":\"148\", \"43\":\"149\",\"44\":\"150\",\"45\":\"151\",\"46\":\"152\",\"47\":\"153\",\"48\":\"154\",\"49\":\"155\",\"50\":\"156\", \"60\":\"157\", \"61\":\"158\", \"62\":\"159\", \"63\":\"160\", \"64\":\"161\", \"65\":\"162\", \"66\":\"163\", \"67\":\"164\", \"68\":\"181\", \"69\":\"165\", \"70\":\"166\", \"71\":\"167\", \"72\":\"168\", \"73\":\"169\", \"74\":\"170\", \"75\":\"171\", \"76\":\"172\"}}";

    public static String getValue(String area, String street, String community) {
        JSONObject map = JSON.parseObject(dateMap);
        if (StringUtils.isNotEmpty(community)) {
            JSONObject com = map.getJSONObject("community");
            return String.valueOf(com.get(community));
        } else if (StringUtils.isNotEmpty(street)) {
            JSONObject s = map.getJSONObject("street");
            return String.valueOf(s.get(street));
        } else if (StringUtils.isNotEmpty(area)) {
            JSONObject a = map.getJSONObject("area");
            return String.valueOf(a.get(area));
        } else
            return "null";
    }

    public static String getKey(String area, String street, String community, String shelters, String isolation) {
        JSONObject map = JSON.parseObject(dateMap);
        JSONObject sheltersJson = null;
        JSONObject isolationJson = null;
        List<SysDictData> corresponding= DictUtils.getDictCache("corresponding_user");
        if (corresponding!=null){
            List<String> labels = corresponding.stream().filter(i -> "shelters".equals(i.getDictLabel()))
                    .map(SysDictData::getDictValue).collect(Collectors.toList());
            if (!labels.isEmpty())
                sheltersJson = JSON.parseObject(labels.get(0));
            List<String> isolations = corresponding.stream().filter(i -> "isolation".equals(i.getDictLabel()))
                    .map(SysDictData::getDictValue).collect(Collectors.toList());
            if (!isolations.isEmpty())
                isolationJson = JSON.parseObject(isolations.get(0));
        }
        if (StringUtils.isNotEmpty(community)) {
            JSONObject com = map.getJSONObject("community");
            return getKey(com,community);
        } else if (StringUtils.isNotEmpty(street)) {
            JSONObject s = map.getJSONObject("street");
            return getKey(s,street);
        } else if (StringUtils.isNotEmpty(area)) {
            JSONObject a = map.getJSONObject("area");
            return getKey(a,area);
        } else if (StringUtils.isNotEmpty(shelters)) {
//            JSONObject a = map.getJSONObject("shelters");
            if (sheltersJson!=null)
                return getKey(sheltersJson,shelters);
            else
                return "";
        } else if (StringUtils.isNotEmpty(isolation)) {
            if (isolationJson!=null)
                return getKey(isolationJson,isolation);
            else
                return "";
//            JSONObject a = map.getJSONObject("isolation");
        } else
            return "null";
    }

    public static String getKey(JSONObject jsonObject, String value) {
        String keyValue = "";
        Iterator<String> keys = jsonObject.keySet().iterator();// jsonObject.keys();
        while (keys.hasNext()) {
            String key = keys.next();
            if (((String) jsonObject.get(key)).equals(value)) {
                keyValue = key.toString();
                break;
            }
        }
        return keyValue;
    }
}
